#ifndef TRANSFORM_H
#define TRANSFORM_H


#include "common.h"

#include "TFMatrix.h"


//-----------------------------------------------------------------//
// 新旧、型の変換クラス
//-----------------------------------------------------------------//
class Transform
{
public:
    std::vector<std::vector<double> > mics;
    std::vector<std::vector<double> > srcs;
    TFMatrix* old_matrix;

public:
    Transform()
    {
        old_matrix = NULL;
    }

public:
    ~Transform()
    {
        delete old_matrix;
    }


//--------------------------------------------------//
// メソッド
//--------------------------------------------------//
public:
    // M2PG::TF_LIST_TYPE(HARKIO伝達関数) -> TFMatrix(旧形式)
    void HARKIOTFToTFMatirxM2PG(harkio::M2PG::TF_LIST_TYPE* tf , TFMatrix& matrix_m2pg);
//    TFMatrix& HARKIOTFToTFMatirxM2PG(harkio::M2PG::TF_LIST_TYPE* tf);//new Matrix作成
//    TFMatrix& HARKIOTFToTFMatirxGTF(harkio::GTF::TF_LIST_TYPE* tf);
    void HARKIOTFToTFMatirxGTF(harkio::GTF::TF_LIST_TYPE* tf , TFMatrix& matrix_gtf);


    /*
    void BasicData(HT::UIData& data, int* mic, int* src, int* fft, int* fs);
    TFMatrix<HT_COMPLEX_DATA_TYPE>& commonTFMatrix(HT::UIData& data);
    TFMatrix<HT_COMPLEX_DATA_TYPE>& commonIFFTTFMatrix(HT::UIData& arg_data);

    // M2PG::TF_LIST_TYPE(HARKIO伝達関数) -> TFMatrix(旧形式)
    TFMatrix<HT_COMPLEX_DATA_TYPE>& HARKIOTFToTFMatirx(harkio::M2PG::TF_LIST_TYPE* tf);
    TFMatrix<HT_COMPLEX_DATA_TYPE>& HARKIOTFToTFMatirx(harkio::GTF::TF_LIST_TYPE* tf);

    // vector<UISrc<T> >(旧形式マイク) -> std::vector<std::vector<T> > (GNUPlot散布図)
    std::vector<std::vector<double> >& OldMicToGNUPlotVector(std::vector<HT::UIMic<HT_DATA_TYPE> >* mic);

    // vector<UISrc<T> >(旧形式ソース) -> std::vector<std::vector<T> > (GNUPlot散布図)
    std::vector<std::vector<double> >& OldSrcToGNUPlotVector(std::vector<HT::UISrc<HT_DATA_TYPE> >* src);

    // M2PG::SRC_LIST_TYPE(HARKIOマイク) -> std::vector<std::vector<T> > (GNUPlot散布図)
    std::vector<std::vector<double> >& HARKIOMicToGNUPlotVector(harkio::FMT::MIC_LIST_TYPE* mic);

    // FMT::MIC_LIST_TYPE(HARKIOソース) -> std::vector<std::vector<T> > (GNUPlot散布図)
    std::vector<std::vector<double> >& HARKIOSrcToGNUPlotVector(harkio::M2PG::SRC_LIST_TYPE* src);

*/


};






#endif // TRANSFORM_H
