#include <QtGui/QApplication>
#include "mainwindow.h"
#include <QSplashScreen>


//------------------------------------------//
// ヘッダー
//------------------------------------------//
#include "TFMatrix.h"
#include "transform.h"
#include "axis.h"
#include "PlotControl.h"
#include "GnuPlot.h"
#include "ScatterPlot.h"





int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

    QTextCodec::setCodecForCStrings(QTextCodec::codecForLocale());

    QTranslator  tra;
    QString fname;
    bool ret;
    //system 言語が,日本語意外の場合英語に設定する
    if ( QLocale::Japanese != QLocale::system().language() )
    {
        std::cout << " Language is English" <<   std::endl;

        fname = QCoreApplication::applicationDirPath() + "/../share/harktool4/trans/harktool4.qm";

        std::cout << "fname =" << fname.toStdString().c_str() << std::endl;

        ret = tra.load( fname.toStdString().c_str()  ,  qApp->applicationDirPath() );

        if(ret)
        {
            a.installTranslator( &tra );
        }
        else
        {
            std::cout<< "# Can't open English translation file:" << fname.toStdString() << std::endl;
        }
    }


    MainWindow w;

    w.show();

    return a.exec();
}
