
#include "transform.h"




/*

//-------------------------------------------------------//
// GTF::TF_LIST_TYPE(HARKIO伝達関数) -> TFMatrix(旧形式)
//-------------------------------------------------------//
MainWindow::TFMatrix &MainWindow::Transform::HARKIOTFToTFMatirxGTF(harkio::GTF::TF_LIST_TYPE* tf)
{

    uint NSrc      = (*tf).size();
    uint NMic      = (*tf)[0].size();
    uint NFFTplus1 = (*tf)[0][0].size();

    delete old_matrix;
    old_matrix = new TFMatrix<HT_COMPLEX_DATA_TYPE> (3, NFFTplus1, NMic, NSrc);

    // ライブラリTFデータをコピーする
    for (uint src = 0; src < NSrc; src++)
    {
        for (uint mic = 0; mic < NMic; mic++)
        {
            for (uint fft = 0; fft < NFFTplus1; fft++)
            {
                (*old_matrix).matrix[fft][mic][src] = HT_COMPLEX_DATA_TYPE(
                                                        (*tf)[src][mic][fft].real(),
                                                        (*tf)[src][mic][fft].imag());
            }
        }
    }
    return *old_matrix;
}


*/


//-------------------------------------------------------//
// M2PG::TF_LIST_TYPE(HARKIO伝達関数) -> TFMatrix(旧形式)
//-------------------------------------------------------//
void Transform::HARKIOTFToTFMatirxM2PG(harkio::M2PG::TF_LIST_TYPE* tf , TFMatrix& matrix_m2pg)
{

    uint NSrc      = (*tf).size();
    uint NMic      = (*tf)[0][0].size();
    uint NFFTplus1 = (*tf)[0][0][0].size();

    delete old_matrix;  //TFMatrix* old_matrix;
    old_matrix = new TFMatrix (3, NFFTplus1, NMic, NSrc);//new matrix作成


    // ライブラリTFデータをコピーする
    for (uint src = 0; src < NSrc; src++)
    {
        for (uint mic = 0; mic < NMic; mic++)
        {
            for (uint fft = 0; fft < NFFTplus1; fft++)
            {
                (*old_matrix).matrix[fft][mic][src]
                                      = std::complex<double>((*tf)[src][0][mic][fft].real(),
                                                             (*tf)[src][0][mic][fft].imag());
            }
        }
    }
    matrix_m2pg = *old_matrix;
//    return *old_matrix;
}



// GTF::TF_LIST_TYPE(HARKIO伝達関数) -> TFMatrix(旧形式)
void Transform::HARKIOTFToTFMatirxGTF(harkio::GTF::TF_LIST_TYPE* tf , TFMatrix& matrix_gtf)
//TFMatrix&  Transform::HARKIOTFToTFMatirxGTF(harkio::GTF::TF_LIST_TYPE* tf)
{

    // tf[ns][nmic][nf]
    uint NSrc      = (*tf).size();
    uint NMic      = (*tf)[0].size();
    uint NFFTplus1 = (*tf)[0][0].size();

    delete old_matrix;
    old_matrix = new TFMatrix (3, NFFTplus1, NMic, NSrc);//new matrix作成

    // ライブラリTFデータをコピーする
    for (uint src = 0; src < NSrc; src++)
    {
        for (uint mic = 0; mic < NMic; mic++)
        {
            for (uint fft = 0; fft < NFFTplus1; fft++)
            {
                (*old_matrix).matrix[fft][mic][src]
                        = std::complex<double>((*tf)[src][mic][fft].real(),
                                               (*tf)[src][mic][fft].imag());
            }
        }
    }

    matrix_gtf = *old_matrix;
//    return *old_matrix;


}






/* takenaka
//---------------------------------------------------------
// vector<UISrc<T> >(旧形式マイク) -> std::vector<std::vector<T> > (GNUPlot散布図)
//---------------------------------------------------------
std::vector<std::vector<double> >& OldMicToGNUPlotVector(std::vector<HT::UIMic<HT_DATA_TYPE> >* mic)
{

    mics.resize(0);
    mics.resize(mic->size());
    for (uint i = 0; i < mic->size(); i++) {
        mics[i].push_back((*mic)[i].x);
        mics[i].push_back((*mic)[i].y);
        mics[i].push_back((*mic)[i].z);
    }
    return mics;
}


//---------------------------------------------------------
// vector<UISrc<T> >(旧形式ソース) -> std::vector<std::vector<T> > (GNUPlot散布図)
//---------------------------------------------------------
std::vector<std::vector<double> >& OldSrcToGNUPlotVector(std::vector<HT::UISrc<HT_DATA_TYPE> >* src)
{

    srcs.resize(0);
    srcs.resize(src->size());
    for (uint i = 0; i < src->size(); i++) {
        srcs[i].push_back((*src)[i].x);
        srcs[i].push_back((*src)[i].y);
        srcs[i].push_back((*src)[i].z);
    }
    return srcs;
}



//---------------------------------------------------------
// M2PG::SRC_LIST_TYPE(HARKIOマイク) -> std::vector<std::vector<T> > (GNUPlot散布図)
//---------------------------------------------------------
std::vector<std::vector<double> >& HARKIOMicToGNUPlotVector(harkio::FMT::MIC_LIST_TYPE* mic)
{

    mics.resize(0);
    mics.resize(mic->size());
    for (uint i = 0; i < mic->size(); i++) {
        mics[i].push_back((*mic)[	i].x);
        mics[i].push_back((*mic)[i].y);
        mics[i].push_back((*mic)[i].z);
    }
    return mics;
}


//---------------------------------------------------------
// FMT::MIC_LIST_TYPE(HARKIOソース) -> std::vector<std::vector<T> > (GNUPlot散布図)
//---------------------------------------------------------
std::vector<std::vector<double> >& HARKIOSrcToGNUPlotVector(harkio::M2PG::SRC_LIST_TYPE* src)
{

    srcs.resize(0);
    srcs.resize(src->size());
    for (uint i = 0; i < src->size(); i++)
    {
        srcs[i].push_back((*src)[i][0].x);
        srcs[i].push_back((*src)[i][0].y);
        srcs[i].push_back((*src)[i][0].z);
    }
    return srcs;
}

takenaka */



