#include "tspcreatetemplate.h"
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "common.h"



TSPcreateTemplate::TSPcreateTemplate(QWidget *parent) :
    QMainWindow(parent)
{





}




void MainWindow::TSPcreateTemplate()
{

try {

        double elvfrom    = 0; // 仰角開始
        double elvint     = 0; // 仰角間隔
        double elvto      = 0;
        int numelv        = 0; // 仰角数

        double heightfrom =0; // 高さ開始
        double heightto   = 0 ;
        double heightint  = 0 ; // 高さ間隔

        double hcount     = 0;
        double tcount     = 0;
        double azifrom    = 0; //方位角
        double azito      = 0;
        double aziint     = 0;

        int numheight     = 0; // 高さ数
        int result =0;




        qDebug("createTemplate [%s][%d]\n" , __FILE__, __LINE__ );

        //--------------------------------------------------------//
        // 球面座標 or 円柱座標 check
        //--------------------------------------------------------//
        int coordinate = 0;

        if (ui->tsp_spherical->isChecked()) //球面座標?
        {
            coordinate = 0; //球面座標
        }
        else
        {
            coordinate = 1; //円柱座標
        }



        //--------------------------------------------------------//
        // radius(距離)
        //--------------------------------------------------------//
        double radius = ui->tsp_radiusfrom->value();



        switch(coordinate)
        {
        //------------------------------------------------------------//
        //  球面座標                                                  //
        //------------------------------------------------------------//
        case 0:
            {
                elvfrom = ui->tsp_elvfrom->value(); // 仰角開始
                elvto   = ui->tsp_elvto->value();   // 仰角終了
                elvint  = ui->tsp_elvint->value();  // 仰角間隔

                if( elvto != elvfrom)
                {
                    tcount = (elvto - elvfrom) / elvint;
                }

                numelv = ( (int)ceil(tcount) ) +1; //切り上げ  // 仰角数

                qDebug("elvfrom[%f] elvint[%f] numelv[%d]\n", elvfrom,  elvint , numelv);

                break;

            }
        //------------------------------------------------------------//
        //  円柱座標                                                  //
        //------------------------------------------------------------//
        case 1:
            {
                //--------------------------------------------------------//
                // height(高さ)
                //--------------------------------------------------------//
                heightfrom = ui->tsp_heightfrom->value(); // 高さ開始
                heightto   = ui->tsp_heightto->value();
                heightint  = ui->tsp_heightint->value(); // 高さ間隔

                if(heightto != heightfrom)
                {
                    hcount = double((heightto*1000) - (heightfrom*1000)) / (heightint*1000);
                }

                numheight = ((int)ceil(hcount)) + 1;//切りあげ // 高さ数


                qDebug("heightfrom[%f] heightint[%f] numheight[%d]\n", heightfrom,  heightint , numheight);

                break;
            }

        }//switch


        //--------------------------------------------------------//
        // AZIMUTH(方位角)
        //--------------------------------------------------------//
         azifrom = ui->tsp_azifrom->value(); // 方位角開始
         azito   = ui->tsp_azito->value();   // 方位角終了

        if(azifrom >= azito)
        {
            azifrom = azifrom - 360;
        }

         aziint = ui->tsp_aziint->value(); //方位角間隔

        double fcount = double(azito - azifrom) / aziint;
        int count= (int)fcount + 1;


        int numazi     = count;    // 方位角数



        QString list_file_template  = ui->tsp_filename->text();                  // ファイル名テンプレート
        int synchronous_avg         = ui->tsp_sync->value();                     // 同期加算回数
        QString original_impulse    = ui->tsp_org_impfile->text();               // 元インパルスファイル
        int tsp_offset              = ui->tsp_offset->value();                   // TSPオスセット
        int signal_max              = ui->tsp_signal_max->value();               // シグナルマックス
        QString channel_list        = ui->tsp_mic_list->text();                  // チャンネルリスト
        QString use_channel_list    = (ui->tsp_mic_flg->isChecked()? "" : "#");  // チャンネルリストチェックボックスON
        int offset_start            = ui->tsp_cut_start->value();                // cut開始
        int offset_end              = ui->tsp_cut_end->value();                  // cut終了
        int mic_cnt = 0;



        // 一時ディレクトリを生成
        boost::filesystem::path temp_dir = CreateTemporaryDirectory();
        boost::filesystem::path hark_config_file_path = temp_dir / "TSPListFile.xml";

        qDebug() << "hark_config_file_path.c_str() =" << hark_config_file_path.c_str() ;


        if(ui->tsp_mic_flg->isChecked() == true )
        {

            char c;

            for (int i =0 ; i < channel_list.length();i++)
            {
                 c = channel_list.toStdString().c_str()[i];
                if(c == ',' )
                {
                    mic_cnt++;
                }
            }

            mic_cnt++; //文字数カウントのため +1

        }
        else
        {
            mic_cnt =8;
            channel_list = "0,1,2,3,4,5,6,7";
        }


        qDebug("mic_cnt[%d]\n",mic_cnt);
        qDebug("channel_list[%s]\n", channel_list.toStdString().c_str());






        switch(coordinate)
        {
            //------------------------------------------------------------//
            //  球面座標(仰角)                                             //
            //------------------------------------------------------------//
            case 0:
            {
                qDebug("*---------------------------------------------------------*\n");
                qDebug("harktool4_cui \n"
                                "--mode template \n"
                                "--output-file %s \n"
                                "--output-format xml \n"
                                "--output-type tsp \n"
                                "--nummic %d \n"
                                "--azifrom %f \n"
                                "--aziint %f \n"
                                "--numazi %d \n"
                                "--elvfrom %f \n"
                                "--elvint %f \n"
                                "--numelv %d \n"
                                "--radius %f \n"

                                "--cut-start %d \n"
                                "--cut-end   %d \n"
                                "--filepath %s \n"

                                "--original-impulse-file %s \n"
                                "--synchronous-average %d \n"
                                "--tsp-offset %d \n"
                                "--tsp-length 16384 \n"
                                "--signal-max %d \n"
                                "--mic-channels %s \n"

                            , "TSPListFile.xml"
                            , mic_cnt
                            , azifrom
                            , aziint
                            , numazi
                            , elvfrom
                            , elvint
                            , numelv
                            , radius
                            , offset_start  //-cut-start
                            , offset_end    //-cut-start
                            , list_file_template.toStdString().c_str() //-filepath
                            , original_impulse.toStdString().c_str()  // --original-impulse-file
                            , synchronous_avg  //--synchronous-average
                            , tsp_offset //--tsp-offset
                            , signal_max   //-signal-max
                            , channel_list.toStdString().c_str()

                );

                qDebug("*---------------------------------------------------------*\n");


                // TSPLISTFILEを作成
                result = ::system((boost::format("harktool4_cui "
                                "--mode template "
                                "--output-file %s "
                                "--output-format xml "
                                "--output-type tsp "
                                "--nummic %d "
                                "--azifrom %f --aziint %f --numazi %d "
                                "--elvfrom %f --elvint %f --numelv %d "
                                "--radius %f "
                                "--cut-start %d "
                                "--cut-end %d "
                                "--filepath %s "
                                "--original-impulse-file %s --synchronous-average %d "
                                "--tsp-offset %d --tsp-length 16384 --signal-max %d "
                                "--mic-channels %s "
                                )
                            % hark_config_file_path
                            % mic_cnt
                            % azifrom % aziint % numazi
                            % elvfrom % elvint % numelv
                            % radius
                            % offset_start
                            % offset_end
                            % list_file_template.toStdString()
                            % original_impulse.toStdString() % synchronous_avg
                            % tsp_offset % signal_max
                            % channel_list.toStdString()).str().c_str());
            }
                break;

            //------------------------------------------------------------//
            //  円柱座標(高さ使用)                                         //
            //------------------------------------------------------------//
            default:
            {
                qDebug("*---------------------------------------------------------*\n");
                qDebug("harktool4_cui \n"
                                "--mode template \n"
                                "--output-file %s \n"
                                "--output-format xml \n"
                                "--output-type tsp \n"
                                "--nummic %d "
                                "--azifrom %f \n"
                                "--aziint %f \n"
                                "--numazi %d \n"
                                "--heightfrom %f \n"
                                "--heightint %f \n"
                                "--numheight %d \n"
                                "--radius %f \n"
                                "--cut-start %d \n"
                                "--cut-end   %d \n"
                                "--filepath %s \n"
                                "--original-impulse-file %s \n"
                                "--synchronous-average %d \n"
                                "--tsp-offset %d \n"
                                "--tsp-length 16384 \n"
                                "--signal-max %d \n"
                                "--mic-channels %s \n"
                            , "TSPListFile.xml"
                            , mic_cnt
                            , azifrom
                            , aziint
                            , numazi
                            , heightfrom
                            , heightint
                            , numheight
                            , radius
                            , offset_start
                            , offset_end
                            , list_file_template.toStdString().c_str()
                            , original_impulse.toStdString().c_str()
                            , synchronous_avg
                            , tsp_offset
                            , signal_max
                            , channel_list.toStdString().c_str()
                );

                qDebug("*---------------------------------------------------------*\n");


                result = ::system((boost::format("harktool4_cui "
                                "--mode template "
                                "--output-file %s "
                                "--output-format xml "
                                "--output-type tsp "
                                "--nummic %d "
                                "--azifrom %f    --aziint %f    --numazi %d "
                                "--heightfrom %f --heightint %f --numheight %d "
                                "--radius %f "
                                "--cut-start %d "
                                "--cut-end   %d "
                                "--filepath %s "
                                "--original-impulse-file %s --synchronous-average %d "
                                "--tsp-offset %d --tsp-length 16384 --signal-max %d "
                                "--mic-channels %s "
                                )
                            % hark_config_file_path
                            % mic_cnt
                            % azifrom % aziint % numazi
                            % heightfrom % heightint % numheight
                            % radius
                            % offset_start
                            % offset_end
                            % list_file_template.toStdString()
                            % original_impulse.toStdString() % synchronous_avg
                            % tsp_offset % signal_max
                            % channel_list.toStdString()).str().c_str());
            }
        }//swutch


        if (result != 0)
        {
            THROW_CRITICAL(trUtf8("harktool4_cuiコマンドを正常に実行できませんでした"));
        }


        //----------------------------------------------------------------//
        // 作成したテンプレートを読み込む
        //----------------------------------------------------------------//
//        std::cout << "作成したテンプレートを読み込む=" << hark_config_file_path.c_str() << std::endl;

        //整形処理
        ::system((boost::format("tidy -o %s -xml -utf8 -w 255 -c -q -asxml -i %s ")
                                % hark_config_file_path.c_str()
                                % hark_config_file_path.c_str()).str().c_str());


        QFile hark_config(hark_config_file_path.c_str());

        if (!hark_config.open(QIODevice::ReadOnly))
        {
            THROW_CRITICAL(trUtf8("Can not read hark_config_file"));
        }

        QTextStream inbuf(&hark_config);
        QString outbuf = inbuf.readAll();
        qDebug() << outbuf;
        ui->tsp_textEdit->setStyleSheet(" color: white;font: bold 16px;");
        ui->tsp_textEdit->setText(outbuf);
        qDebug() << "harktool4_cui Ok" ;

        //-----------------------------------------------------------------//
        // hark_config_file_pathを格納する
        //-----------------------------------------------------------------//
        m_plotctl[m_out_page_no].tsp_hark_path = hark_config_file_path;





    }
    catch (std::exception& exp)
    {
//        DISP_DIALOG(exp);
        return;
    }
    return;


}
